﻿package  
{
	import com.flashdynamix.motion.TweensyZeroMinified;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	
	/**
	 * ...
	 * @author Yves Trublin
	 */
	public class Lecteur extends Sprite
	{
		private var nbPhoto:int;
		private var delaiPhoto:Number;
		private var nbPhotosDispo:int;
		private var timer:Timer;
		
		private var grLecture:Shape;
		private var grPause:Shape;
				
		public function Lecteur(np:int) 
		{
			nbPhoto = np;
			
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init, false, 0, true);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			tabEnabled = false;
			
			// initialisations
			delaiPhoto = root["xml"].@["delaiPhoto"];
			
			// fond
			graphics.beginFill(root["xml"].@["couleurFondBoutonLecturePause"], root["xml"].@["alphaFondBoutonLecturePause"]);
			graphics.drawRect(-13, 0, 13, 13);
			graphics.endFill();
			
			// lecture
			grLecture = new Shape();
			grLecture.graphics.beginFill(root["xml"].@["couleurBoutonLecturePause"], root["xml"].@["alphaBoutonLecturePause"]);
			grLecture.graphics.moveTo(2, 2);
			grLecture.graphics.lineTo(11, 6.5);
			grLecture.graphics.lineTo(2, 11);
			grLecture.graphics.endFill();
			grLecture.visible = false;
			grLecture.x = - 13;
			addChild(grLecture);
			
			// pause
			grPause = new Shape();
			grPause.graphics.beginFill(root["xml"].@["couleurBoutonLecturePause"], root["xml"].@["alphaBoutonLecturePause"]);
			grPause.graphics.drawRect(2, 2, 3, 9);
			grPause.graphics.drawRect(8, 2, 3, 9);
			grPause.graphics.endFill();
			grPause.visible = false;
			grPause.x = - 13;
			addChild(grPause);
			
			if (root["xml"].@["lectureAutomatique"] == "true") {
				grPause.visible = true;
				lecture();
			}else {
				grLecture.visible = true;
			}
			
			// ecouteurs
			addEventListener(MouseEvent.MOUSE_OVER, handleMouseOverOut, false, 0, true);
			addEventListener(MouseEvent.MOUSE_OUT, handleMouseOverOut, false, 0, true);
			addEventListener(MouseEvent.CLICK, handleMouseClick, false, 0, true);
			
			buttonMode = true;
			mouseChildren = false;
		}
		
		private function handleMouseClick(e:MouseEvent):void 
		{
			if (grPause.visible) {
				// en lecture
				pause();
				
			}else {
				// en pause
				lecture();
			}
			grPause.visible = !grPause.visible;
			grLecture.visible = !grLecture.visible;
		}
		
		private function handleMouseOverOut(e:MouseEvent):void 
		{
			var sc:Number = 1;
			if (e.type == MouseEvent.MOUSE_OVER) {
				sc = 1.8;
			}
			TweensyZeroMinified.to(this.transform.matrix, { a:sc, d:sc }, .5, null, this);
		}
		
		///////////////////////////////////////////////////////////
		// lance le diaporama
		///////////////////////////////////////////////////////////
		private function lecture():void {
			timer = new Timer(delaiPhoto);
			timer.addEventListener(TimerEvent.TIMER, handleTimer, false, 0, true);
			timer.start();
		}
		
		private function handleTimer(e:TimerEvent):void 
		{
			if (root["photoCour"] < nbPhotosDispo - 1 || nbPhotosDispo == nbPhoto) {
				root["photoCour"] = (root["photoCour"] + 1) % nbPhotosDispo;
				root["montrerPhotoCourante"]();
				if (timer.delay == 500) {
					timer.delay = delaiPhoto;
				}
			}else {
				timer.delay = 500;
			}
		}
		
		///////////////////////////////////////////////////////////
		// pause le diaporama
		///////////////////////////////////////////////////////////
		private function pause():void {
			timer.removeEventListener(TimerEvent.TIMER, handleTimer);
			timer.reset();
			timer = null;
		}
		
		///////////////////////////////////////////////////////////
		// getter / setter
		///////////////////////////////////////////////////////////
		// fonction d'actualisation du nombre de photos disponibles
		public function set nombrePhotosDispo(n:int):void
		{
			nbPhotosDispo = n;
		}
	}
}