﻿package  
{
	import com.flashdynamix.motion.TweensyZeroMinified;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.PixelSnapping;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	/**
	 * ...
	 * @author yves trublin
	 */
	public class Miniature extends Sprite
	{
		private var tailleMiniature:Number;
		private var bitmapData:BitmapData;
		private var fond:Shape;
		private var estActive:Boolean = false;
		private var couleurFondMiniature:uint;
		
		public function Miniature(tm:Number, bmd:BitmapData) 
		{
			tailleMiniature = tm;
			bitmapData = bmd;
			
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init, false, 0, true);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			// initialisation
			couleurFondMiniature = root["xml"].@["couleurFondMiniature"];
			
			fond = new Shape();
			fond.graphics.beginFill(couleurFondMiniature, 1);
			fond.graphics.drawRect(0, 0, tailleMiniature, tailleMiniature);
			fond.alpha = 0;
			addChild(fond);
			
			var ratio:Number = Utils.calculerRatio(bitmapData.width, bitmapData.height, tailleMiniature, tailleMiniature) * (1 - root["xml"].@["reductionMiniature"]);
			var bmd:BitmapData = new BitmapData(bitmapData.width * ratio, bitmapData.height * ratio);
			bmd.draw(bitmapData, new Matrix(ratio, 0, 0, ratio));
			bmd.lock();
			
			var bmp:Bitmap = new Bitmap(bmd, PixelSnapping.AUTO, true);
			bmp.x = (tailleMiniature - bmp.width) * .5;
			bmp.y = (tailleMiniature - bmp.height) * .5;
			addChild(bmp);
			
			buttonMode = true;
			mouseChildren = false;
			
			addEventListener(MouseEvent.MOUSE_OVER, handleOverOut, false, 0, true);
			addEventListener(MouseEvent.MOUSE_OUT, handleOverOut, false, 0, true);
		}
		
		private function handleOverOut(e:MouseEvent):void 
		{
			if(!estActive){
				var alpha:Number = 0;
				if (e.type == MouseEvent.MOUSE_OVER) {
					alpha = .5;
				}
				TweensyZeroMinified.to(fond.transform.colorTransform, { alphaMultiplier:alpha }, .5, null, fond);
			}
		}
		
		public function activerMiniature():void
		{
			estActive = true;
			TweensyZeroMinified.to(fond.transform.colorTransform, { alphaMultiplier:1 }, 1, null, fond);
		}

		public function desactiverMiniature():void
		{
			estActive = false;
			TweensyZeroMinified.to(fond.transform.colorTransform, { alphaMultiplier:0 }, .5, null, fond);
		}
	}
}